# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_rtp; MdkRtp; end
module MdkRtp
require "datawire-quark-core"
require_relative 'quark/reflect' # 0 ('quark',) ()
require_relative 'mdk_protocol' # 0 () ()


##
# Create a JSONParser that can read all messages to/from the MCP.

def self.getRTPParser()
    
    parser = ::Quark.mdk_protocol.JSONParser.new()
    parser.register("open", ::Quark.quark.reflect.QuarkClass.get("mdk_protocol.Open"))
    parser.register("mdk.protocol.Open", ::Quark.quark.reflect.QuarkClass.get("mdk_protocol.Open"))
    parser.register("close", ::Quark.quark.reflect.QuarkClass.get("mdk_protocol.Close"))
    parser.register("mdk.protocol.Close", ::Quark.quark.reflect.QuarkClass.get("mdk_protocol.Close"))
    parser.register("discovery.protocol.Close", ::Quark.quark.reflect.QuarkClass.get("mdk_protocol.Close"))
    parser.register("active", ::Quark.quark.reflect.QuarkClass.get("mdk_discovery.protocol.Active"))
    parser.register("discovery.protocol.Expire", ::Quark.quark.reflect.QuarkClass.get("mdk_discovery.protocol.Expire"))
    parser.register("expire", ::Quark.quark.reflect.QuarkClass.get("mdk_discovery.protocol.Expire"))
    parser.register("discovery.protocol.Expire", ::Quark.quark.reflect.QuarkClass.get("mdk_discovery.protocol.Expire"))
    parser.register("clear", ::Quark.quark.reflect.QuarkClass.get("mdk_discovery.protocol.Clear"))
    parser.register("discovery.protocol.Clear", ::Quark.quark.reflect.QuarkClass.get("mdk_discovery.protocol.Clear"))
    parser.register("log", ::Quark.quark.reflect.QuarkClass.get("mdk_tracing.protocol.LogEvent"))
    parser.register("logack", ::Quark.quark.reflect.QuarkClass.get("mdk_tracing.protocol.LogAck"))
    parser.register("mdk_tracing.protocol.LogAckEvent", ::Quark.quark.reflect.QuarkClass.get("mdk_tracing.protocol.LogAck"))
    parser.register("subscribe", ::Quark.quark.reflect.QuarkClass.get("mdk_tracing.protocol.Subscribe"))
    parser.register("interactionevent", ::Quark.quark.reflect.QuarkClass.get("mdk_metrics.InteractionEvent"))
    parser.register("interactionack", ::Quark.quark.reflect.QuarkClass.get("mdk_metrics.InteractionAck"))
    return parser


    nil
end
end # module MdkRtp
end # module Quark
