# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_tracing; MdkTracing; end
module MdkTracing
def self.api; Api; end
module Api
require "datawire-quark-core"
require_relative '../quark/reflect' # 0 ('quark',) ('mdk_tracing',)
require_relative '../mdk_protocol' # 0 () ('mdk_tracing',)
require_relative '../quark' # 0 () ('mdk_tracing',)
require_relative 'protocol' # 1 () ()


def self.ApiHandler; ApiHandler; end
class ApiHandler < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_tracing_api_ApiHandler_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Retrieves zero or more events based on the provided request parameters.

    def getLogEvents(request)
        raise NotImplementedError, '`ApiHandler.getLogEvents` is an abstract method'

        nil
    end

    def __init_fields__()
        

        nil
    end


end
ApiHandler.unlazy_statics

def self.GetLogEventsRequest; GetLogEventsRequest; end
class GetLogEventsRequest < ::Quark.mdk_protocol.Serializable
    attr_accessor :startTime, :endTime
    extend ::DatawireQuarkCore::Static

    static mdk_tracing_api_GetLogEventsRequest_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def self.decode(encoded)
        
        return ::DatawireQuarkCore.cast(::Quark.mdk_protocol.Serializable.decodeClassName("mdk_tracing.api.GetLogEventsRequest", encoded)) { ::Quark.mdk_tracing.api.GetLogEventsRequest }

        nil
    end

    def _getClass()
        
        return "mdk_tracing.api.GetLogEventsRequest"

        nil
    end

    def _getField(name)
        
        if ((name) == ("startTime"))
            return (self).startTime
        end
        if ((name) == ("endTime"))
            return (self).endTime
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("startTime"))
            (self).startTime = ::DatawireQuarkCore.cast(value) { ::Integer }
        end
        if ((name) == ("endTime"))
            (self).endTime = ::DatawireQuarkCore.cast(value) { ::Integer }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.startTime = 0
        self.endTime = ::Quark.quark.now()

        nil
    end


end
GetLogEventsRequest.unlazy_statics

def self.GetLogEventsResult; GetLogEventsResult; end
class GetLogEventsResult < ::Quark.mdk_protocol.Serializable
    attr_accessor :result
    extend ::DatawireQuarkCore::Static

    static quark_List_mdk_tracing_protocol_LogEvent__ref: -> { nil }
    static mdk_tracing_api_GetLogEventsResult_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def self.decode(encoded)
        
        return ::DatawireQuarkCore.cast(::Quark.mdk_protocol.Serializable.decodeClassName("mdk_tracing.api.GetLogEventsResult", encoded)) { ::Quark.mdk_tracing.api.GetLogEventsResult }

        nil
    end

    def _getClass()
        
        return "mdk_tracing.api.GetLogEventsResult"

        nil
    end

    def _getField(name)
        
        if ((name) == ("result"))
            return (self).result
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("result"))
            (self).result = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.result = nil

        nil
    end


end
GetLogEventsResult.unlazy_statics


require_relative '../datawire_mdk_md' # 0 () ('mdk_tracing',)

end # module Api
end # module MdkTracing
end # module Quark
