# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
def self.quark; Quark; end
module Quark
def self.os; Os; end
module Os
require "datawire-quark-core"
require_relative 'reflect' # 1 () ()
require_relative 'error' # 1 () ()
require_relative 'concurrent' # 1 () ()


def self.OSError; OSError; end
class OSError < ::Quark.quark.error.Error
    extend ::DatawireQuarkCore::Static

    static quark_os_OSError_ref: -> { nil }



    def initialize(message)
        
        super(message)

        nil
    end




    def _getClass()
        
        return "quark.os.OSError"

        nil
    end

    def _getField(name)
        
        if ((name) == ("message"))
            return (self).message
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("message"))
            (self).message = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        super

        nil
    end


end
OSError.unlazy_statics

def self.FileContents; FileContents; end
class FileContents < ::Quark.quark.concurrent.Future
    attr_accessor :value
    extend ::DatawireQuarkCore::Static

    static quark_os_FileContents_ref: -> { nil }



    def initialize()
        
        super()

        nil
    end




    def _getClass()
        
        return "quark.os.FileContents"

        nil
    end

    def _getField(name)
        
        if ((name) == ("_context"))
            return (self)._context
        end
        if ((name) == ("_finished"))
            return (self)._finished
        end
        if ((name) == ("_error"))
            return (self)._error
        end
        if ((name) == ("_callbacks"))
            return (self)._callbacks
        end
        if ((name) == ("_lock"))
            return (self)._lock
        end
        if ((name) == ("value"))
            return (self).value
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("_context"))
            (self)._context = ::DatawireQuarkCore.cast(value) { ::Quark.quark.concurrent.Context }
        end
        if ((name) == ("_finished"))
            (self)._finished = ::DatawireQuarkCore.cast(value) { ::Object }
        end
        if ((name) == ("_error"))
            (self)._error = ::DatawireQuarkCore.cast(value) { ::Quark.quark.error.Error }
        end
        if ((name) == ("_callbacks"))
            (self)._callbacks = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::List }
        end
        if ((name) == ("_lock"))
            (self)._lock = ::DatawireQuarkCore.cast(value) { ::DatawireQuarkCore::Lock }
        end
        if ((name) == ("value"))
            (self).value = ::DatawireQuarkCore.cast(value) { ::String }
        end

        nil
    end

    def __init_fields__()
        
        super
        self.value = nil

        nil
    end


end
FileContents.unlazy_statics

##
# Read the entire contents of a file into a String. Assume UTF-8 encoding.
# Returns a FileContents Future instance.
# if result.getError() is null then result.value has the file contents.

def self.readFileAsString(path)
    
    result = ::Quark.quark.os.FileContents.new()
    ::DatawireQuarkCore.getFileContents((path), (result))
    return result


    nil
end

##
# Return the path to the current user's home directory

def self.getUserHomeDir()
    
    return Dir.home()


    nil
end

def self.Environment; Environment; end
##
# Class for interacting with the process environment

class Environment < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static ENV: -> { ::Quark.quark.os.Environment.new() }
    static quark_os_Environment_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    ##
    # Retrieve the Environment singleton

    def self.getEnvironment()
        
        return ::Quark.quark.os.Environment.ENV

        nil
    end

    ##
    # Fetch the value of an environment variable.
    # Returns null if the variable is not set.

    def __get__(key)
        
        return ENV[key]

        nil
    end

    ##
    # Fetch the value of an environment variable.
    # Returns the specified default if the variable is not set.

    def get(key, default_value)
        
        value = ENV[key]
        if ((value) == (nil))
            return default_value
        end
        return value

        nil
    end

    ##
    # Fetch the value of $USER

    def self.getUser()
        
        return ENV["USER"]

        nil
    end

    def _getClass()
        
        return "quark.os.Environment"

        nil
    end

    def _getField(name)
        
        if ((name) == ("ENV"))
            return ::Quark.quark.os.Environment.ENV
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("ENV"))
            ::Quark.quark.os.Environment.ENV = ::DatawireQuarkCore.cast(value) { ::Quark.quark.os.Environment }
        end

        nil
    end

    def __init_fields__()
        

        nil
    end


end
Environment.unlazy_statics


require_relative '../datawire_mdk_md' # 0 () ('quark',)

end # module Os
end # module Quark
end # module Quark
