# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_introspection; MdkIntrospection; end
module MdkIntrospection
def self.aws; Aws; end
module Aws
require "datawire-quark-core"
require_relative '../quark/reflect' # 0 ('quark',) ('mdk_introspection',)
require_relative '../mdk_introspection' # 0 () ('mdk_introspection',)
require_relative '../mdk_runtime' # 0 () ('mdk_introspection',)


def self.Ec2Host; Ec2Host; end
class Ec2Host < ::DatawireQuarkCore::QuarkObject
    attr_accessor :scope, :env
    extend ::DatawireQuarkCore::Static

    static mdk_introspection_aws_Ec2Host_ref: -> { nil }



    def initialize(env, scope)
        
        self.__init_fields__
        (self).scope = (scope).upcase
        (self).env = env

        nil
    end




    def self.metadataHost(env)
        
        return env.var("DATAWIRE_METADATA_HOST_OVERRIDE").orElseGet("169.254.169.254")

        nil
    end

    def get()
        
        if ((@scope) == ("INTERNAL"))
            return ::DatawireQuarkCore.url_get((("http://") + (::Quark.mdk_introspection.aws.Ec2Host.metadataHost(@env))) + ("/latest/meta-data/local-hostname"))
        end
        if ((@scope) == ("PUBLIC"))
            return ::DatawireQuarkCore.url_get((("http://") + (::Quark.mdk_introspection.aws.Ec2Host.metadataHost(@env))) + ("/latest/meta-data/public-hostname"))
        end
        return ::DatawireQuarkCore.cast(nil) { ::String }

        nil
    end

    def _getClass()
        
        return "mdk_introspection.aws.Ec2Host"

        nil
    end

    def _getField(name)
        
        if ((name) == ("scope"))
            return (self).scope
        end
        if ((name) == ("env"))
            return (self).env
        end
        return nil

        nil
    end

    def _setField(name, value)
        
        if ((name) == ("scope"))
            (self).scope = ::DatawireQuarkCore.cast(value) { ::String }
        end
        if ((name) == ("env"))
            (self).env = ::DatawireQuarkCore.cast(value) { ::Quark.mdk_runtime.EnvironmentVariables }
        end

        nil
    end

    def __init_fields__()
        
        self.scope = nil
        self.env = nil

        nil
    end


end
Ec2Host.unlazy_statics


require_relative '../datawire_mdk_md' # 0 () ('mdk_introspection',)

end # module Aws
end # module MdkIntrospection
end # module Quark
