# Quark 1.0.452 run at 2016-11-28 14:25:58.554098
module Quark
require "quark"
def self.mdk_util; MdkUtil; end
module MdkUtil
require "datawire-quark-core"
require_relative 'quark/reflect' # 0 ('quark',) ()
require_relative 'mdk_runtime/promise' # 0 ('mdk_runtime',) ()
require_relative 'quark' # 0 () ()


def self.WaitForPromise; WaitForPromise; end
##
# Utility to blockingly wait for a Promise to get a value.

class WaitForPromise < ::DatawireQuarkCore::QuarkObject
    extend ::DatawireQuarkCore::Static

    static mdk_util_WaitForPromise_ref: -> { nil }



    def initialize()
        self.__init_fields__

        nil
    end




    def _finished(value, done)
        
        done.acquire()
        done.wakeup()
        done.release()
        return true

        nil
    end

    def self.wait(p, timeout, description)
        
        snapshot = p.value()
        if (snapshot.hasValue())
            return snapshot.getValue()
        end
        done = ::DatawireQuarkCore::Condition.new()
        waiter = ::Quark.mdk_util.WaitForPromise.new()
        p.andThen(::Quark.quark._BoundMethod.new(waiter, "_finished", ::DatawireQuarkCore::List.new([done])))
        msTimeout = ((timeout) * (1000.0)).round()
        done.acquire()
        done.waitWakeup(msTimeout)
        done.release()
        snapshot = p.value()
        if (!(snapshot.hasValue()))
            raise (("Timeout waiting for ") + (description))
        end
        return snapshot.getValue()

        nil
    end

    def _getClass()
        
        return "mdk_util.WaitForPromise"

        nil
    end

    def _getField(name)
        
        return nil

        nil
    end

    def _setField(name, value)
        
        nil

        nil
    end

    def __init_fields__()
        

        nil
    end


end
WaitForPromise.unlazy_statics

def self.toNativePromise(p)
    
    if (!(false))
        raise ("This method only works on Javascript.")
    end
    return


    nil
end

def self.extend(list, value, size)
    
    while (((list).size) < (size)) do
        (list) << (value)
    end


    nil
end

def self.versionMatch(requested, actual)
    
    if ((requested) == (nil))
        return true
    end
    reqparts = ::DatawireQuarkCore.split(requested, ".")
    actparts = ::DatawireQuarkCore.split(actual, ".")
    ::Quark.mdk_util.extend(reqparts, "0", 2)
    ::Quark.mdk_util.extend(actparts, "0", 2)
    reqmajor = ::Quark.quark.ParsedInt.new(((reqparts)[0]).strip).getValue()
    actmajor = ::Quark.quark.ParsedInt.new(((actparts)[0]).strip).getValue()
    reqminor = ::Quark.quark.ParsedInt.new(((reqparts)[1]).strip).getValue()
    actminor = ::Quark.quark.ParsedInt.new(((actparts)[1]).strip).getValue()
    if ((reqmajor) != (actmajor))
        return false
    end
    if ((actminor) >= (reqminor))
        return true
    end
    return false


    nil
end


require_relative 'datawire_mdk_md' # 0 () ()

end # module MdkUtil
end # module Quark
